#define PBITMAP BITMAP ptr

#include Once "allegro.bi"
#Include Once "log.bi"
#Include Once "bfont.bi"
#Include Once "acrodat.bi"

#Define SCREENW 800
#Define SCREENH 600
#Define BPP 16

#Define RESDIR "acrores/"

'Enum EGameState 'this didn't work?
'   MENU = 1
'   PLAYING
'   GAMEOVER
'End Enum
'dim Shared GameState As EGameState
#Define GSMENU 1
#Define GSPLAYING 2
#Define GSGAMEOVER 3
#Define GSQUIT 4

dim Shared GameState As Integer

dim Shared gcounter As Integer
dim Shared Level As Integer
dim Shared Tries As Integer
dim Shared BouncersCaught As integer

common Shared Backbuffer as PBITMAP 

dim Shared DatFile As datafile ptr

#Define friction 0.01
#Define GRAVITY 0.1

#Define startx 30
#Define starty 510

#Define BounceForce -7.1

declare Sub gtimer cdecl ()
Declare Sub SpawnBouncer()
Declare Function  AnyBouncers() As Integer
Declare Function OktoSpawn() As Integer
Declare Sub InitAllegro()
Declare Sub GameMain()   
Declare Sub CleanUp()
Declare Sub InitGameBitmaps()
Declare Sub DoSplash()
Declare Function rndRange(first As Integer,last As Integer)As Integer
Declare Sub InitFont()
Declare Sub Play_Alleg_Fli()
Declare Sub DoFBLogo()
Declare Sub DoAd()


Type Trampoline
	x As Integer
	slot As Integer
	Declare Sub Move()
End Type

Type Bouncer
	bmp As pbitmap
	x As Integer
	y As Integer
	w As Integer
	h As Integer
	frame As Integer
	exists As Integer
	slot As Integer
	vx As single
	vy As single
	angle As single
	scale As Single
	xpos As Single
	ypos As Single
	halfw As Single
	halfh As single
	Declare Sub Move(ByVal TrampSlot As integer)
End Type

Sub bouncer.Move(ByVal TrampSlot As Integer)
	
If Not exists  Then Exit sub

	Select Case xpos
		Case 0 To 314
			slot = 1
		Case 315 To 504
			slot = 2
		Case 505 To 800
			slot = 3
	End Select

		
	If xpos > screenw + halfw + 10  Then
		BouncersCaught += 1
		xpos=startx
		ypos=starty
		angle = 0
		vy = bounceforce
		exists = false
	End if	
	 
	If ypos > starty And ypos < starty + 10 Then
		If xpos > 700 Then
			vy = BounceForce
			ypos = starty
			angle = 0
			Play_Sample(datfile[doboing].dat,255,255,1000,0)
		elseIf slot = trampslot then
			vy = BounceForce
			ypos = starty
			angle = 0
			Play_Sample(datfile[doboing].dat,255,128,1000,0)
		End if   
	End If
	
	If ypos > screenh + halfh + 10 Then 
		play_sample(datfile[dodie].dat,255,128,1000,0)
		exists = FALSE
		tries -= 1
	EndIf
	
	angle += 2
	If angle > 255 Then angle = 255
	If angle < 0 Then angle = 0
		
	xpos = xpos + vx
	ypos = ypos + vy
	
	x = xpos - halfw
	y = ypos - halfh
	
	vy += GRAVITY
	
	frame = 2
	If ypos < 450 Then frame = 1
	If ypos < 425 Then frame = 0
	
End Sub

Sub Trampoline.Move()
Select Case mouse_x
	Case 0 To 314
		x = 170
		slot = 1
	Case 315 To 504
		x = 360
		slot = 2
	Case 505 To 800
		x = 540
		slot = 3
End Select
	
End Sub