#include Once "globals.bi"

#Define Cannoposx -20
#Define Cannoposy 498

Dim shared templayer(9) As Bouncer
Dim Shared Tramp As Trampoline
Dim Shared MyFont As BFont

Sub InitFont()
	With MyFont
	  .bmp = datfile[dofont].dat
	  .w = 22
	  .h = 30
	  .pitch(0) = 22
	  .pitch(1) = 11
	  .pitch(2) = 13
	  .pitch(3) = 18
	  .pitch(4) = 13
	  .pitch(5) = 14
	  .pitch(6) = 19
	  .pitch(7) = 14
	  .pitch(8) = 13
	  .pitch(9) = 13
	  .pitch(10) = 8
	  .pitch(11) = 11
	  .pitch(12) = 11
	  .pitch(13) = 14
	  .pitch(14) = 8
	  .pitch(15) = 14
	  .pitch(16) = 18
	  .pitch(17) = 15
	  .pitch(18) = 16
	  .pitch(19) = 15
	  .pitch(20) = 14
	  .pitch(21) = 15
	  .pitch(22) = 17
	  .pitch(23) = 14
	  .pitch(24) = 16
	  .pitch(25) = 16
	  .pitch(26) = 8
	  .pitch(27) = 8
	  .pitch(28) = 10
	  .pitch(29) = 13
	  .pitch(30) = 10
	  .pitch(31) = 16
	  .pitch(32) = 15
	  .pitch(33) = 22
	  .pitch(34) = 20
	  .pitch(35) = 18
	  .pitch(36) = 20
	  .pitch(37) = 17
	  .pitch(38) = 20
	  .pitch(39) = 19
	  .pitch(40) = 18
	  .pitch(41) = 14
	  .pitch(42) = 14
	  .pitch(43) = 17
	  .pitch(44) = 15
	  .pitch(45) = 22
	  .pitch(46) = 19
	  .pitch(47) = 16
	  .pitch(48) = 19
	  .pitch(49) = 17
	  .pitch(50) = 22
	  .pitch(51) = 14
	  .pitch(52) = 18
	  .pitch(53) = 15
	  .pitch(54) = 19
	  .pitch(55) = 22
	  .pitch(56) = 20
	  .pitch(57) = 19
	  .pitch(58) = 22
	  .pitch(59) = 12
	  .pitch(60) = 14
	  .pitch(61) = 10
	  .pitch(62) = 10
	  .pitch(63) = 22
	  .pitch(64) = 9
	  .pitch(65) = 13
	  .pitch(66) = 15
	  .pitch(67) = 12
	  .pitch(68) = 15
	  .pitch(69) = 15
	  .pitch(70) = 17
	  .pitch(71) = 16
	  .pitch(72) = 16
	  .pitch(73) = 7
	  .pitch(74) = 10
	  .pitch(75) = 14
	  .pitch(76) = 11
	  .pitch(77) = 17
	  .pitch(78) = 15
	  .pitch(79) = 13
	  .pitch(80) = 15
	  .pitch(81) = 14
	  .pitch(82) = 14
	  .pitch(83) = 12
	  .pitch(84) = 13
	  .pitch(85) = 13
	  .pitch(86) = 14
	  .pitch(87) = 16
	  .pitch(88) = 15
	  .pitch(89) = 16
	  .pitch(90) = 14
	  .pitch(91) = 15
	  .pitch(92) = 14
	  .pitch(93) = 13
	  .pitch(94) = 10
	End With
End Sub

Function rndRange(first As Integer,last As Integer)As integer
	Function = CInt(Rnd * (last - first) + first)
End Function

Sub gtimer cdecl ()
	 gcounter += 1
End sub      

Sub SpawnBouncer()
	Dim i As Integer
	
	For i = 0 To 9
		If Not templayer(i).exists Then
			templayer(i).bmp = datfile[doacro0].dat
			templayer(i).xpos = startx
			templayer(i).ypos = starty
			templayer(i).angle = 0
			templayer(i).exists = true
			templayer(i).w = 99
			templayer(i).h = 108
			Select Case CInt(Rnd)
				Case 0
					templayer(i).vx = 2.6
				Case 1
					templayer(i).vx = 1.3
				Case Else
					templayer(i).vx = 1.3
			End Select
			templayer(i).vy = BounceForce
			templayer(i).halfw = templayer(i).w/2
			templayer(i).halfh = templayer(i).h/2
			play_sample(datfile[docannons].dat,255,64,1000,0)
			Exit for
		EndIf
	Next
End Sub

Function  AnyBouncers() As Integer
	Dim i As Integer
	Dim numBouncers As Integer
	
	numBouncers = 0
	For i = 0 To 9
		If templayer(i).exists Then numbouncers += 1
	Next
	Function = numbouncers
End Function

Function OktoSpawn() As Integer
	Dim i As Integer
	Dim xok As integer
	Function = TRUE
	Select Case level
		Case 0 To 2
			xok = rndRange(300,700)
		Case 3 To 7
			xok = rndRange(200,700)
		Case else
			xok = rndRange(100,700)
	End Select
	
	For i = 0 To 9
		If templayer(i).exists Then
			If templayer(i).ypos > starty - templayer(i).h Then 
				Function = FALSE
				Exit for
			End if
			If templayer(i).xpos < xok Then 
				function = FALSE
				Exit For
			End if   
		EndIf
	Next
End Function

Sub InitAllegro()   	
Dim card As Integer

	randomize timer     
	Card = GFX_AUTODETECT_FULLSCREEN'GFX_AUTODETECT_WINDOWED'GFX_DIRECTX_SOFT'GFX_DIRECTX_SAFE'
	allegro_init()
	#If BPP = 32
	  set_color_depth(32)
	  If set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0 then
		  #Ifdef LOGGING
			  Logit "Error setting GFX mode."
		  #EndIf 
		  End -1
	  End if
	#Else
	  set_color_depth(16)
	  If  set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0 Then
			set_color_depth(15)
			If set_gfx_mode(Card, SCREENW, SCREENH, 0, 0) < 0 Then
			  #Ifdef LOGGING
					Logit "Error setting GFX mode."
			  #EndIf 
			  End -1
			End if
		 End if 
	#EndIf
	set_color_conversion COLORCONV_TOTAL 
	
	Backbuffer = create_bitmap(SCREEN_W,SCREEN_H)
	clear_to_color(Backbuffer, makecol(0, 0, 0))
	
	install_keyboard
	install_mouse
	install_timer
	 
	LOCK_FUNCTION (gtimer)
	LOCK_VARIABLE (gcounter)
	install_int_ex (@gtimer,BPS_TO_TIMER(33))
	#Ifdef LOGGING
		Logit "Allegro init"
	#EndIf 

	If( install_mouse() < 0 ) then
		textout_centre(Backbuffer, font, "No mouse detected, but you need one!", _
                     SCREEN_W\2, SCREEN_H\2, makecol(0, 0, 0))
		readkey()
		GameState = GSQUIT
	End If
	
	install_sound(DIGI_AUTODETECT ,MIDI_AUTODETECT, NULL) 
	GameState = gsmenu
	
End Sub

Sub GameMain()
	Dim i As Integer
	MyFont.exists = TRUE
	Do while GameState <> GSQUIT  
	poll_keyboard()
	poll_mouse()	
	Select Case GameState
		Case GSPlaying	
			Do While gcounter <> 0
				clear_keybuf()
				If OktoSpawn() then
					SpawnBouncer()
				End If
				tramp.Move
				For i = 0 To 9
					templayer(i).move(tramp.slot)
				Next
				level = BouncersCaught \ 4 +1
				gcounter -= 1
			Loop      
			blit(datfile[doback].dat, Backbuffer,0,0,0,0,screenw,screenh)
			masked_blit(datfile[docannonb].dat,backbuffer,0,0,Cannoposx,Cannoposy,108,18)               
			masked_blit(datfile[dotree].dat,backbuffer,0,0,460,130,295,308)               
			For i = 0 To 9
				Select Case templayer(i).frame
					Case 0
						templayer(i).bmp = datfile[doacro0].dat
					Case 1
						templayer(i).bmp = datfile[doacro1].dat
					Case 2
						templayer(i).bmp = datfile[doacro2].dat
					End Select
				If templayer(i).exists then  
					rotate_sprite(backbuffer,templayer(i).bmp,templayer(i).x,templayer(i).y,ftofix(templayer(i).angle))
				End if
			next

			masked_blit(datfile[docannonf].dat,backbuffer,0,0,Cannoposx,Cannoposy,100,102)
			masked_blit(datfile[dotramp].dat,backbuffer,0,0,tramp.x,565,99,34)               
			masked_blit(datfile[dotramp].dat,backbuffer,0,0,740,565,99,34)               

			MyFont.x = 10
			MyFont.y = 10
			MyFont.DrawText backbuffer, "Level " + Str(level)
			
			MyFont.x = screenw - myfont.GetStringWidth( "Tries  " + Str(tries) )
			MyFont.y = 10
			MyFont.DrawText backbuffer, "Tries " + Str(tries)
			
			If tries < 1 Then GameState = GSGAMEOVER
			If Key(KEY_ESC) Then GameState = GSGAMEOVER
		
		Case GSMenu
			blit(datfile[domenu].dat, Backbuffer,0,0,0,0,screenw,screenh)
			With myfont
			.x = (screenw \ 2) - (.GetStringWidth( "Press @P' to play game." ) \ 2)
			.y = 500
			.DrawText backbuffer, "Press @P' to play game."
			.x = (screenw \ 2) - (.GetStringWidth( "Press @ESC' to quit." ) \ 2)
			.y += .h + 10
			.DrawText backbuffer, "Press @ESC' to quit."
			End With
			
			If Key(KEY_P) Then
				tries = 5
				Level = 0
				BouncersCaught = 0
				gcounter = 0
				For i = 0 To 9
					templayer(i).bmp = datfile[doacro0].dat
					templayer(i).xpos = startx
					templayer(i).ypos = starty
					templayer(i).angle = 0
					templayer(i).exists = false
					templayer(i).w = 99
					templayer(i).h = 108
					templayer(i).vx = 1.3
					templayer(i).vy = BounceForce
					templayer(i).halfw = templayer(i).w/2
					templayer(i).halfh = templayer(i).h/2
				Next i
				GameState = GSPLAYING
			EndIf
			
			If Key(KEY_ESC) Then GameState = GSQUIT
 
		Case GSGameOver
			blit(datfile[doback].dat, Backbuffer,0,0,0,0,screenw,screenh)
			masked_blit(datfile[docannonf].dat,backbuffer,0,0,Cannoposx,Cannoposy,100,102)
			masked_blit(datfile[dotramp].dat,backbuffer,0,0,740,565,99,34 )
			masked_blit(datfile[dotree].dat,backbuffer,0,0,460,130,299,308 )              
			With myfont
				.x = (screenw \ 2) - (.GetStringWidth( "GameOver" )\ 2)
				.y = 100
				.DrawText backbuffer, "GameOver"
				.x = (screenw \ 2) - (.GetStringWidth( "Press @P' to Play again." ) \ 2)
				.y += .h + 10
				.DrawText backbuffer, "Press @P' to Play again."
				.x = (screenw \ 2) - (.GetStringWidth( "Or" ) \ 2)
				.y += .h + 10
				.DrawText backbuffer, "Or"
				.x = (screenw \ 2) - (.GetStringWidth( "Press @Q' to quit." ) \ 2)
				.y += .h + 10
				.DrawText backbuffer, "Press @Q' to quit."
			End With
			
			If Key(KEY_P) Then
				tries = 5
				Level = 0
				BouncersCaught = 0
				gcounter = 0
				For i = 0 To 9
					templayer(i).bmp = datfile[doacro0].dat
					templayer(i).xpos = startx
					templayer(i).ypos = starty
					templayer(i).angle = 0
					templayer(i).exists = false
					templayer(i).w = 99
					templayer(i).h = 108
					templayer(i).vx = 1.3
					templayer(i).vy = BounceForce
					templayer(i).halfw = templayer(i).w/2
					templayer(i).halfh = templayer(i).h/2
				Next i
				GameState = GSPLAYING
			EndIf 
			
			If Key(KEY_Q) Then GameState = GSMENU
			
	End Select  
	
	vsync()
	blit(Backbuffer, Screen,0,0,0,0,screenw,screenh)
Loop   
	
End Sub

Sub InitGameBitmaps()
	Dim i As Integer
	
	datfile = load_datafile( resdir + "acro.dat" )
	If datfile = NULL Then Logit "Not dat file."
	For i = 0 To 9
		templayer(i).bmp = datfile[doacro0].dat
		templayer(i).xpos = startx
		templayer(i).ypos = starty
		templayer(i).angle = 0
		templayer(i).exists = false
		templayer(i).w = 99
		templayer(i).h = 108
		templayer(i).vx = 1.3
		templayer(i).vy = BounceForce
		templayer(i).halfw = templayer(i).w/2
		templayer(i).halfh = templayer(i).h/2
	Next i
	InitFont
End Sub

Sub DoSplash()
	Dim bmp As PBITMAP
	
	bmp = Load_Bitmap(resdir + "logo2.bmp",NULL)
	blit(bmp, Screen, 0 ,0 ,(screenw/2) - (bmp->w/2),(screenh/2) - (bmp->h/2), bmp->w, bmp->h)
	rest(5000)
	destroy_bitmap(bmp)
	
End Sub

Sub DoAd()
	Dim bmp As PBITMAP
	
	bmp = Load_Bitmap(resdir + "youradhere.bmp",NULL)
	blit(bmp, Screen, 0 ,0 ,(screenw/2) - (bmp->w/2),(screenh/2) - (bmp->h/2), bmp->w, bmp->h)
	ReadKey()
	destroy_bitmap(bmp)
	
End Sub

Sub DoFBLogo()
	Dim bmp As PBITMAP
	
	bmp = Load_Bitmap( resdir + "fblogo.bmp",NULL)
	clear_to_color( Screen, makecol( 0,0,0))'255,255,255 ))
	blit( bmp, Screen, 0 ,0 ,(screenw/2) - (bmp->w/2),(screenh/2) - (bmp->h/2), bmp->w, bmp->h )
	textout Screen,font,"This Game is made",596,520,makecol( 255,255,255 )
	textout Screen,font,"with, but in no way",580,530,makecol( 255,255,255 )
	textout Screen,font,"endorsed by, the",605,540,makecol( 255,255,255 )
	textout Screen,font,"excellent free BASIC",572,550,makecol( 255,255,255 )
	textout Screen,font,"compiler-FreeBASIC",588,560,makecol( 255,255,255 )
	textout Screen,font,"www.freebasic.net",597,570,makecol( 255,255,255 )
	rest( 5000 )
	destroy_bitmap( bmp )
	
End Sub

Sub Play_Alleg_Fli()
	Dim canvas As PBITMAP
	clear_to_color( Screen, makecol( 0,0,0))
	canvas = create_sub_bitmap( Screen,240,180,320,240 )
	textout Screen,font,"This Game is made",596,520,makecol( 255,255,255 )
	textout Screen,font,"with, but in no way",580,530,makecol( 255,255,255 )
	textout Screen,font,"endorsed by, the",605,540,makecol( 255,255,255 )
	textout Screen,font,"excellent game lib",589,550,makecol( 255,255,255 )
	textout Screen,font,"ALLEGRO",677,560,makecol( 255,255,255 )
	textout Screen,font,"www.allgro.cc",630,570,makecol( 255,255,255 )
	Play_fli(RESDIR + "allegro.fli",canvas,0,NULL)
	rest( 2000 )
	
	destroy_bitmap(canvas)
End Sub

Sub CleanUp()   	
	unload_datafile( datfile )
	destroy_bitmap(Backbuffer)
End Sub
Kill "log.txt"
InitAllegro
DoSplash
'DoAd
DoFblogo
Play_Alleg_Fli
InitGameBitmaps
play_MIDI(datfile[domusic].dat,1)
GameMain
CleanUp
END_OF_MAIN()