
#Define CELLSPERROW 20

Type BFont
	bmp As PBITMAP
	x As Integer
	y As Integer
	w As Integer
	h As Integer
	exists As integer
	pitch(94) As Integer
	
	Declare Sub GetFontProps()
	Declare Sub DrawText(ByVal DstBmp As PBITMAP, ByVal sText As String, ByVal ColKey As integer = True)
	Declare Function GetStringWidth(ByVal sText As String) As integer
End Type
Sub BFont.DrawText(ByVal DstBmp As PBITMAP, ByVal sText As String, ByVal ColKey As integer = True)
Dim n As integer
Dim x2 As integer
Dim LastChar As Integer
Dim frame As Integer
If exists then
	For n = 1 To Len(sText)
		Frame = (Asc(Mid$(sText, n, 1))) - 32
		If n = 1 Then
			x2 = X
		Else
			x2 = x2 + Pitch(LastChar) + 1
		End If
		LastChar = Frame
		If colkey then
			Masked_blit(bmp,dstBmp,(frame Mod CELLSPERROW) * w,(frame \ CELLSPERROW) * h + 1, _
							x2,y,w,h) 
		Else
			blit(bmp,dstBmp,(frame Mod CELLSPERROW) * w,(frame \ CELLSPERROW) * h + 1, _
				  x2,y,w,h)
		End if               
		
	Next n
End if   
End Sub
Function BFont.GetStringWidth(ByVal sText As String) As Integer
Dim n As integer
Dim totalwidth As integer
Dim LastChar As Integer
Dim frame As Integer
totalwidth = 0
For n = 1 To Len(sText)
	Frame = (Asc(Mid$(sText, n, 1))) - 32
	If n = 1 Then
		totalwidth = Pitch(Frame) + 1
	Else
		totalwidth = totalwidth + Pitch(LastChar) + 1
	End If
	LastChar = Frame
Next n
Function = totalwidth
End Function

Sub bfont.GetFontProps()
	Dim ColorValue As Integer
	Dim i As Integer
	colorvalue = getpixel(bmp,0,0)
	w = getr(colorvalue)
	colorvalue = getpixel(bmp,1,0)
	h = getr(colorvalue)
	For i = 0 To 94
		colorvalue = getpixel(bmp,i+2,0)
		pitch(i) = getr(colorvalue)
	Next
End Sub